<?php
/*******************************************************************************

    Author ......... Mathieu Virbel
    Contact ........ mathieu.v@capensis.fr
    Home Site ...... http://capensis.org/
    Program ........ realtime
    Version ........ 0.2
    Purpose ........ add realtime view of any graph

*******************************************************************************/

define('REALTIME_REALM_ID', '81');

function plugin_init_realtime()
{
    // This is where you hook into the plugin archetecture
    global $plugin_hooks;
	$plugin_hooks['config_arrays']['realtime'] = 'realtime_config_arrays';
	$plugin_hooks['graph_buttons']['realtime'] = 'realtime_graph_buttons';
}

function realtime_version ()
{
	return array(
		'name'    => 'realtime',
		'version'   => '0.2',
		'longname'  => 'Realtime for Cacti',
		'author'    => 'Mathieu Virbel',
		'homepage'  => 'http://capensis.org/',
		'email'	=> 'mathieu.v@capensis.fr',
		'url'      => 'http://cactiusers.org/cacti/versions.php'
	);
}

function realtime_config_arrays ()
{
	$realm_id = REALTIME_REALM_ID;
	global $user_auth_realms, $user_auth_realm_filenames;
	$user_auth_realms[$realm_id] = 'Realtime';
	$user_auth_realm_filenames['graph_image_rt.php'] = $realm_id;
}

function realtime_graph_buttons($args)
{
	global $config;
	$local_graph_id = $args[1]['local_graph_id'];
	echo "<a href='#' onclick=\"window.open('".$config['url_path']."plugins/realtime/graph_popup_rt.php?local_graph_id=".$local_graph_id."', 'popup_".$local_graph_id."', 'toolbar=0,menubar=0,location=0,scrollbars=1,width=650,height=300')\"><img src='".$config['url_path']."plugins/realtime/monitor_rt.png' border='0' alt='Realtime' title='Realtime' style='padding: 3px;'></a><br/>";
	realtime_setup_table();
}

function realtime_setup_table()
{
	global $config, $database_default;

	include_once($config["library_path"] . "/database.php");

	/* realm_id */
    $realm_id = REALTIME_REALM_ID;
    $sql = "show columns from host from " . $database_default;
    $result = mysql_query($sql) or die (mysql_error());
    $found = false;
    while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
        if ($row['Field'] == 'myplugin')
            $found = true;
    }
    if (!$found) {
        $sql = "alter table host add myplugin char(3) default 'on' not null after disabled";
        $result = mysql_query($sql) or die (mysql_error());
        $sql = "INSERT INTO `user_auth_realm` VALUES ($realm_id, 1);";
        $result = mysql_query($sql); // or die (mysql_error());
    }

	/* tables for realtime */
	$result = db_fetch_assoc('show tables');
	$tables = array();
	$sql = array();

	if (count($result) > 1) {
		foreach($result as $index => $arr) {
			foreach ($arr as $t) {
				$tables[] = $t;
			}
		}
	}

	if (!in_array('poller_output_rt', $tables))
	{
		db_execute('
			CREATE TABLE IF NOT EXISTS poller_output_rt (
		  		local_data_id mediumint(8) unsigned NOT NULL default \'0\',
		  		rrd_name varchar(19) NOT NULL default \'\',
		  		`time` datetime NOT NULL default \'0000-00-00 00:00:00\',
		  		output text NOT NULL,
		  		poller_id int(11) NOT NULL,
		  		PRIMARY KEY  (local_data_id,rrd_name,`time`)
			) ENGINE=MyISAM DEFAULT CHARSET=latin1;
		');
	}

}

?>
